/****************************************************************************
 *	Copylight(C) 2010 Kanazawa-soft-design,LLC.All Rights Reserved.
 ****************************************************************************/
/*!
 *	@file	sample_0001.cpp
 *
 *	@brief	MME𗘗pTEho̓vO.
 *
 *	@author	V 閾
 */
#include <windows.h>
#include <windowsX.h>
#include <stdio.h>
#include <commctrl.h>
#include <tchar.h>
#include "resource.h"
#include "WaveFile.h"

// ֐vg^Cv.
static LRESULT CALLBACK	SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam );
static void				OnInitDialog( HWND hDlg );
static BOOL				OnSelectFile( HWND hDlg );
static BOOL				PlaySoundOutput( HWND hDlg );
static void				PauseSoundOutput( HWND hDlg );
static void				StopSoundOutput( HWND hDlg );
static BOOL				OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf );
static void				CloseSoundOutputDevice( void );
static void				SoundOutputDone( HWND hDlg, WAVEHDR* wh );
static DWORD			VolumeControl( HWND hVolume );

// [Jϐ.
static BYTE*	DataBuff;				//!< f[^obt@.
static DWORD	DataSize;				//!< f[^TCY.
static HWAVEOUT	hWO;					//!< TEho̓foCX̃nh.
static WAVEHDR	OutHdr[2];				//!< TEho͂̃f[^ubN\.
static TCHAR	FileName[MAX_PATH+1];	//!< ĐWAVt@C̃t@C.

/****************************************************************************/
/*!
 *	@brief	AvP[VEC.
 *
 *	@param	[in]	hInst		݂̃CX^X̃nh.
 *	@param	[in]	hPreInst	ȑÕCX^X̃nh.
 *	@param	[in]	CmdLine		R}hC.
 *	@param	[in]	show		\.
 *
 *	@retval	0Ԃ.
 */
int WINAPI	WinMain( HINSTANCE hInst, HINSTANCE hPreInst, LPSTR CmdLine, int show )
{
	//! [Jϐ.
	DataBuff = NULL;
	DataSize = 0;
	hWO      = NULL;
	memset( OutHdr  , 0, sizeof(OutHdr)   );
	memset( FileName, 0, sizeof(FileName) );

	//! RRg[.
    INITCOMMONCONTROLSEX ic;
	ic.dwSize = sizeof(INITCOMMONCONTROLSEX);
	ic.dwICC  = ICC_COOL_CLASSES;
	InitCommonControlsEx( &ic );

	//! _CAOI[v.
	DialogBox( hInst, MAKEINTRESOURCE(IDD_DIALOG_MAIN), NULL, (DLGPROC)SoundOutProc );

	return 0;
}

/****************************************************************************/
/*!
 *	@brief	_CAÕbZ[WEnh.
 *
 *	@param	[in]	hDlg	_CAO{bNX̃nh.
 *	@param	[in]	msg		bZ[W.
 *	@param	[in]	wParam	ŏ̃bZ[Wp[^.
 *	@param	[in]	lParam	2Ԗڂ̃bZ[Wp[^.
 *
 *	@retval	TRUE  = bZ[W.
 *	@retval	FALSE = bZ[WȂ.
 */
static LRESULT CALLBACK		SoundOutProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ){
	case WM_INITDIALOG:
		OnInitDialog( hDlg );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) ){
		case IDC_FILE_SELECT:
			OnSelectFile( hDlg );
			break;

		case IDC_PLAY:
			PlaySoundOutput( hDlg );
			break;

		case IDC_PAUSE:
			PauseSoundOutput( hDlg );
			break;

		case IDC_STOP:
			StopSoundOutput( hDlg );
			break;

		case IDCANCEL:
			StopSoundOutput( hDlg );
			EndDialog( hDlg, 0 );
			break;

		default:
			return FALSE;
		}
		break;

	case MM_WOM_DONE:
		SoundOutputDone( hDlg, (WAVEHDR*)lParam );
		break;

	case WM_VSCROLL:
		if( GetDlgItem( hDlg, IDC_VOLUME ) == (HWND)lParam ){
			VolumeControl( (HWND)lParam );
		}
		break;

	default:
		break;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	_CAȌ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		OnInitDialog( HWND hDlg )
{
	//! o̓foCXXg쐬.
	DWORD dev_num = waveOutGetNumDevs();
	if( dev_num != 0 ){
		HWND hlist = GetDlgItem( hDlg, IDC_OUTPUT_DEVICE );

		ComboBox_ResetContent( hlist );
		for( DWORD i = 0; i < dev_num; i++ ){
			// o̓foCX̐\擾.
			WAVEOUTCAPS caps;
			if( waveOutGetDevCaps( i, &caps, sizeof(caps) ) == MMSYSERR_NOERROR ){
				ComboBox_AddString( hlist, caps.szPname );
			}
		}
		ComboBox_SetCurSel( hlist, 0 );
	}
	//! ʃ{[̃gbNo[ݒ肷.
	HWND hbar = GetDlgItem( hDlg, IDC_VOLUME );
	SendMessage( hbar, TBM_SETRANGE, TRUE, MAKELONG( 0, 100 ) );
	SendMessage( hbar, TBM_SETPOS  , TRUE, 50 );
}

/****************************************************************************/
/*!
 *	@brief	ĐWAVt@CI.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static BOOL		OnSelectFile( HWND hDlg )
{
	//! TEho͂t@Ct@CI_CAOI.
	OPENFILENAME ofn;
	memset( &ofn     , 0, sizeof(ofn)      );
	memset( &FileName, 0, sizeof(FileName) );
	ofn.lStructSize    = sizeof(ofn);
	ofn.hwndOwner      = hDlg;
	ofn.lpstrFilter    = _T("WAVEt@C(*.wav)\0*.wav\0SẴt@C(*.*)\0*.*\0\0");
	ofn.lpstrFile      = FileName;
	ofn.nMaxFile       = MAX_PATH;
	ofn.Flags          = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt    = NULL;
	ofn.lpstrTitle     = _T("Đt@C");
	if( GetOpenFileName( &ofn ) ){
		SetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName );
		return TRUE;
	}
	return FALSE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@CĐ.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		PlaySoundOutput( HWND hDlg )
{
	//! WAVt@CI[vĂȂꍇAI[v.
	if( !IsOpenWaveFile() ){

		//! -1._CAOĐWAVt@C擾.
		GetWindowText( GetDlgItem( hDlg, IDC_FILENAME ), FileName, sizeof(FileName) - 1 );

		//! -2.ĐWAVt@CI[v.
		if( !ReadOpenWaveFile( FileName ) ){
			MessageBox( hDlg, _T("t@CI[vł܂"), _T("WAVt@C̍Đ"), MB_OK );
			return FALSE;
		}
	}
	if( !hWO ){
		//! I[vWAVt@C̃I[fBIEtB[}bg擾.
		WAVEFORMATEX wf;
		GetAudioFormat( &wf );

		//! TEho̓foCXI[v.
		UINT num = ComboBox_GetCurSel( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ) );
		if( OpenSoundOutDevice( hDlg, num, &wf ) ){
			//! WAVt@C̓ǂݍݗpobt@mۂ.
			if( !DataBuff ){
				DataSize = wf.nAvgBytesPerSec >> 2;		// 1sec / 4 = 250ms.
				DataBuff = new BYTE[DataSize];
			}
			//! {[ݒ_CAO̐ݒɂ킹.
			VolumeControl( GetDlgItem( hDlg, IDC_VOLUME ) );
		}
	}

	//! WAVt@CǂݍŁATEho͂Jn.
	for( DWORD i = 0; i < 2; i++ ){
		//! -1.f[^ubNNA.
		memset( OutHdr[i].lpData, 0, DataSize );

		//! -2.WAVt@Cf[^ubÑf[^ǂݍ.
		ReadWaveFile( OutHdr[i].lpData, DataSize );

		//! -3.ǂݍ񂾃I[fBIEf[^o̓foCXɓ.
		OutHdr[i].dwBufferLength = DataSize;
		waveOutWrite( hWO, &OutHdr[i], sizeof(WAVEHDR) );
	}
	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), FALSE );
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đꎞ~.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *
 *	@retval	Ȃ.
 */
static void		PauseSoundOutput( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundOutputDevice();

	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	WAVt@C̍Đ~.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		StopSoundOutput( HWND hDlg )
{
	//! TEho̓foCXN[Y.
	CloseSoundOutputDevice();

	//! ĐWAVt@CN[Y.
	CloseWaveFile();

	//! WAVt@C̓ǂݍݗpobt@.
	if( DataBuff ){
		delete [] DataBuff;
		DataBuff = NULL;
	}
	EnableWindow( GetDlgItem( hDlg, IDC_PLAY          ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_PAUSE         ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_STOP          ), FALSE );
	EnableWindow( GetDlgItem( hDlg, IDC_FILENAME      ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_FILE_SELECT   ), TRUE  );
	EnableWindow( GetDlgItem( hDlg, IDC_OUTPUT_DEVICE ), TRUE  );
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXI[v.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	num		I[vfoCXԍ.
 *	@param	[in]	wf		ĐWAVt@C̃I[fBI\̂̃|C^.
 *
 *	@retval	TRUE = OK. / FALSE = NG.
 */
static BOOL		OpenSoundOutDevice( HWND hDlg, UINT num, WAVEFORMATEX* wf )
{
	//! o̓foCXI[v.
	if( waveOutOpen( &hWO, num, wf, (DWORD)hDlg, 0, CALLBACK_WINDOW ) != MMSYSERR_NOERROR ){
		return FALSE;
	}
	//! f[^ubNo̓foCXɓo^.
	memset( OutHdr, 0, sizeof(OutHdr) );
	for( int i = 0; i < 2; i++ ){
		OutHdr[i].lpData = new char[wf->nAvgBytesPerSec];
		if( waveOutPrepareHeader( hWO, &OutHdr[i], sizeof(WAVEHDR) ) != MMSYSERR_NOERROR ){
			return FALSE;
		}
	}
	return TRUE;
}

/****************************************************************************/
/*!
 *	@brief	TEho̓foCXN[Y.
 *
 *	@param	Ȃ.
 *
 *	@retval	Ȃ.
 */
static void		CloseSoundOutputDevice( void )
{
	if( hWO ){
		//! -1.TEho͂~.
		waveOutReset( hWO );

		for( int i = 0; i < 2; i++ ){
			//! -2.o̓foCXɓo^f[^ubN.
			waveOutUnprepareHeader( hWO, &OutHdr[i], sizeof(WAVEHDR) );

			//! -3.f[^obt@.
			if( OutHdr[i].lpData ){
				delete [] OutHdr[i].lpData;
				OutHdr[i].lpData = NULL;
			}
		}
		//! -4.o̓foCXN[Y.
		waveOutClose( hWO );
		hWO = NULL;
	}
}

/****************************************************************************/
/*!
 *	@brief	TEho̓f[^̏o͊ʒm.
 *
 *	@param	[in]	hDlg	_CAÕEChEEnh.
 *	@param	[in]	wh		f[^ubN\̂̃|C^.
 *
 *	@retval	Ȃ.
 */
static void		SoundOutputDone( HWND hDlg, WAVEHDR* wh )
{
	if( hWO ){
		if( wh->dwUser == 1 ){
			//! Ō̃f[^̍ĐÎŁAWAVt@C̍ĐIɂ.
			StopSoundOutput( hDlg );
		}else{
			memset( wh->lpData, 0, DataSize );

			//! ɃTEho͂f[^t@Cǂݍ.
			DWORD len = ReadWaveFile( wh->lpData, DataSize );

			//! o͂f[^ȂꍇAf[^ubNɃ}[Nt.
			wh->dwUser = 0;
			if( len == 0 ){
				wh->dwUser = 1;
			}
			//! TEho͂f[^̃oCgf[^ubNɃZbg.
			wh->dwBufferLength = DataSize;

			//! ɃTEho͂f[^ubN𓊓.
			waveOutWrite( hWO, wh, sizeof(WAVEHDR) );
		}
	}
}

/****************************************************************************/
/*!
 *	@brief	ʃ{[ݒύX.
 *
 *	@param	[in]	hVolume	{[Rg[o[̃nh.
 *
 *	@retval	V{[ݒl.
 */
static DWORD	VolumeControl( HWND hVolume )
{
	//! foCXI[vĂȂꍇA{[ݒsȂ.
	if( !hWO ){
		return 0;
	}
	//! _CAO{[Rg[̈ʒu擾.
	DWORD range  = SendMessage( hVolume, TBM_GETPOS, 0, 0 );
	DWORD volume = ((100 - range) * 0xFFFF) / 100;

	//! {[ݒύX.
	DWORD wk_vol = ((volume << 16) & 0xFFFF0000) + (volume & 0xFFFF);
	if( waveOutSetVolume( hWO, wk_vol ) != MMSYSERR_NOERROR ){
		return 0;
	}
	return volume;
}

/* End of file */
